/*
 * Main.c
 *
 *  Created on: Oct 17, 2009
 *      Author: chwolfe2
 */
//#include <gdbm.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>
//#include <sys/mman.h>
#include "Message.h"
#include "Commands.h"
//#include "Defines.h"
//#include "Disk.h"
#include "Time.h"
#include "Log.h"
//#include "FileSystem.h"
//#include "Socket.h"
//#include "RingQueue.h"
//#include "MessageQueue.h"
#include "Persistence.h"
#include "Schedule.h"
#include "Config.h"
#include "DataFormats.h"
#include "HostInterface.h"

#define __IN_MAIN__
#include "Globals.h"
#undef  __IN_MAIN__


void Process_Messaging();

/*

StatusCode Disk_IdentifyAll();
StatusCode Disk_CreateArray(Disk disksToUse[], int count);
StatusCode Disk_Format(char* deviceName);
StatusCode Disk_Mount(char* deviceName);
StatusCode Disk_Unmount(char* deviceName);

StatusCode MessageQueue_Create(MessageQueue* msgQ, char* name);
StatusCode MessageQueue_Destroy(MessageQueue* msgQ);
StatusCode MessageQueue_Enqueue(MessageQueue* msgQ, Message* msg);
StatusCode MessageQueue_Dequeue(MessageQueue* msgQ, Message* msg);

StatusCode RingQueue_Create(RingQueue* rq, size_t insertionSize);
StatusCode RingQueue_Destroy(RingQueue* rq);
StatusCode RingQueue_NextInsertionPoint(RingQueue* rq, char* insertionPoint);
StatusCode RingQueue_NotifyInsertionComplete(RingQueue* rq, size_t bytesInserted);
StatusCode RingQueue_NextRemovalPoint(RingQueue* rq, char* removalPoint);
StatusCode RingQueue_NotifyRemovalComplete(RingQueue* rq, size_t bytesRemoved);

StatusCode Socket_Create(Socket* s);
StatusCode Socket_OpenRecieve(Socket* s, unsigned short port);
StatusCode Socket_OpenSend(Socket* s, char* destinationURL, unsigned short port);
StatusCode Socket_Recieve(Socket* s, char* buffer, size_t* size);
StatusCode Socket_Send(Socket* s, char* buffer, size_t size);
StatusCode Socket_Close(Socket* s);
StatusCode Socket_Destroy(Socket* s);

StatusCode DataFormats_Initialize		(boolean reloadConfig);
StatusCode DataFormats_GetCount			(int* count);
StatusCode DataFormats_GetName			(int index, char * formatName);
StatusCode DataFormats_GetSpec			(int index, char * spec);
StatusCode DataFormats_GetPayloadSize	(int index, size_t * payloadSize);
StatusCode DataFormats_GetRate			(int index, size_t * rate);
StatusCode DataFormats_Get				(char * formatName, DataFormat * result);
StatusCode DataFormats_Compile			(DataFormat * format, CompiledDataFormat* result);
StatusCode DataFormats_Release			(CompiledDataFormat* compiledFormat);
StatusCode DataFormats_Finalize();
void printCompiledFormat(CompiledDataFormat* compiledFormat);

*/

//GDBM_FILE* database, char * fileName, char * defaultsFileName
boolean BootOption_DeleteLog=false;			// -flushLog
boolean BootOption_DeleteSchedule=false;	// -flushSchedule
boolean BootOption_DeleteData=false;		// -flushData
boolean BootOption_ResetConfigData=false;	// -flushConfig
boolean ShutdownOption_Scram = false;
boolean ShutdownOption_Reboot = true;

void ParseBootOptions(int argc, char* argv[]){
	int i = 1;
	while (i<argc){
		printf("Processing option '%s'\n",argv[i]);
		if 			(strcmp(argv[i],"-flushLog")==0) 		BootOption_DeleteLog = true;
		else if 	(strcmp(argv[i],"-flushSchedule")==0) 	BootOption_DeleteSchedule = true;
		else if 	(strcmp(argv[i],"-flushData")==0) 		BootOption_DeleteData = true;
		else if 	(strcmp(argv[i],"-flushConfig")==0) 	BootOption_ResetConfigData = true;
		i++;
	}
}

int main(int argc, char* argv[]){







	//////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////
	//
	//        @@@@@    @@@@   @@@@  @@@@@@
	//        @@  @@  @@  @@ @@  @@   @@
	//        @@@@@   @@  @@ @@  @@   @@
	//        @@  @@  @@  @@ @@  @@   @@
	//        @@@@@    @@@@   @@@@    @@
	//
	//////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////

	StatusCode sc;
	Disk 			disk;
	FileSystem 		fileSystem;
	MessageQueue 	messageQueue;
	MessageQueue 	responseQueue;
	RingQueue 		rxQueue;
	Socket 			rxMsgSocket;
	Socket 			txMsgSocket;
	Socket 			rxSocket;
	bzero((void *)&disk,			sizeof(Disk));
	bzero((void *)&fileSystem,		sizeof(FileSystem));
	bzero((void *)&messageQueue,	sizeof(MessageQueue));
	bzero((void *)&responseQueue,	sizeof(MessageQueue));
	bzero((void *)&rxQueue,			sizeof(RingQueue));
	bzero((void *)&rxMsgSocket,		sizeof(Socket));
	bzero((void *)&txMsgSocket,		sizeof(Socket));
	bzero((void *)&rxSocket,		sizeof(Socket));

	bzero((void*)&globals,sizeof(Globals));
	globals.disk			= &disk;
	globals.fileSystem		= &fileSystem;
	globals.messageQueue	= &messageQueue;
	globals.responseQueue	= &responseQueue;
	globals.rxQueue			= &rxQueue;
	globals.rxMsgSocket		= &rxMsgSocket;
	globals.txMsgSocket		= &txMsgSocket;
	globals.rxSocket		= &rxSocket;
	globals.flushConfigRequested 	= false;
	globals.flushDataRequested 		= false;
	globals.flushLogRequested 		= false;
	globals.flushScheduleRequested 	= false;
	globals.exitRequested			= false;
	globals.shutdownRequested 		= false;
	globals.rebootRequested 		= true;
	globals.scramRequested 			= false;


	DataFormat 			df;
	CompiledDataFormat 	cdf;
	Disk 				extdisk;
	MyFile				tagfile;
	bzero((void *)&df,			sizeof(DataFormat));
	bzero((void *)&cdf,			sizeof(CompiledDataFormat));
	bzero((void *)&extdisk,		sizeof(Disk));
	bzero((void *)&tagfile,		sizeof(MyFile));
	globals.opData.compiledFormat 		= &cdf;
	globals.opData.dataFormat			= &df;
	globals.opData.extdisk				= &extdisk;
	globals.opData.tagfile				= &tagfile;
	globals.opData.initialParameters	= NULL;
	globals.opData.errorCount 			= 0l;
	globals.opData.warningCount 		= 0l;





	//parse command line options
	ParseBootOptions(argc,argv);
	printf("BOOT: Loading system configuration.\n");






	// load configuration
	sc=Config_Initialize(BootOption_ResetConfigData);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not load system configuration.\n Exiting...\n");
		return EXIT_CODE_FAIL;
	}
	char temp[8192];
	Config_Get("MessageInPort",temp);
	globals.MessageInPort = (unsigned short) strtoul(temp,NULL,10);
	Config_Get("MessageOutPort",temp);
	globals.MessageOutPort = (unsigned short) strtoul(temp,NULL,10);
	Config_Get("DataInPort",temp);
	globals.DataInPort = (unsigned short) strtoul(temp,NULL,10);
	Config_Get("MessageOutURL",globals.MessageOutURL);
	Config_Get("MyReferenceDesignator", globals.MyReferenceDesignator);
	Config_Get("TimeAuthority",globals.ntpServer);


	char command[8192];
	sprintf(command, "ntpdate %s", globals.ntpServer);
	char result[8192];
	sc= ShellGetString(command, result, 8192);
	if (sc!=SUCCESS){
		printf("Error: NTP synchronization process failed\n");
	} else {
		printf("NTP synchronization result: '%s'\n",result);
	}


	// initialize the log
	printf("BOOT: Initializing the system log.\n");
	sc = Log_Initialize(BootOption_DeleteLog);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not initialize system log.\n Exiting...\n");
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}


	// initialize the drive devices
	printf("BOOT: Initializing the system's storage devices.\n");
	sc = Disk_IdentifyAll();
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not enumerate system storage devices.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not enumerate system storage devices.");
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("Opened System Log.");

	// find internal storage looking for /dev/md0, then /dev/md1, upto /dev/md5
	printf("BOOT: Locating internal storage among detected devices.\n");
	int arrayNum=0;
	boolean arrayFound=false;
	char arrayDeviceName[128];
	while ((arrayNum < 6)  &&  !arrayFound){
		sprintf(arrayDeviceName, "/dev/md%d", arrayNum);
		sc = Disk_GetDiskInfo(arrayDeviceName, &disk);
		if (sc==SUCCESS){
			arrayFound=true;
		}
		arrayNum++;
	}
	if (!arrayFound){
		printf("BOOT: Fatal Error: Could not locate internal storage among detected devices.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not locate internal storage among detected devices.");
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	} else {
		printf("BOOT: Identified internal storage device as '%s'\n",disk.deviceName);
		Log_Add("BOOT: Identified internal storage device as '%s'",disk.deviceName);
	}

	// possibly create filesystem
	if (BootOption_DeleteData){
		printf("BOOT: Creating internal storage file system.\n");
		sc = FileSystem_Create(&disk);
		if (sc!=SUCCESS){
			printf("BOOT: Fatal Error: Could not create internal storage file system.\nExiting...\n");
			Log_Add("BOOT: Fatal Error: Could not create internal storage file system.");
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		} else {
			printf("BOOT: File system created, all data deleted!!!\n");
			Log_Add("BOOT: File system created, all data deleted!!!");
		}
	}

	// open filesystem
	printf("BOOT: Opening internal storage file system.\n");
	sc = FileSystem_Open(&fileSystem, &disk);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not open internal storage file system.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not open internal storage file system.");
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("Opened internal storage file system.");
	/*printf("globals.fileSystem = %lu \n",(size_t) globals.fileSystem);
	printf("globals.fileSystem->fileSystemHeaderData = %lu \n",(size_t) globals.fileSystem->fileSystemHeaderData);
	printf("globals.fileSystem->fileSystemHeaderData->filesystemInfo.chunkSize = %lu \n",(size_t) globals.fileSystem->fileSystemHeaderData->filesystemInfo.chunkSize);
*/
	// initialize data formats
	printf("BOOT: Opening data formats database.\n");
	sc = DataFormats_Initialize(BootOption_ResetConfigData);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not read data formats database.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not read data formats database.");
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Read data formats database.");


	// create messaging receive socket
	printf("BOOT: Creating messaging receive socket.\n");
	sc = Socket_Create(&rxMsgSocket);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not create messaging receive socket.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not create messaging receive socket.");
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Created messaging receive socket.");

	// create messaging send socket
	printf("BOOT: Creating messaging send socket.\n");
	sc = Socket_Create(&txMsgSocket);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not create messaging send socket.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not create messaging send socket.");
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Created messaging send socket.");

	// open messaging receive socket
	printf("BOOT: Opening messaging receive socket.\n");
	sc = Socket_OpenRecieve(&rxMsgSocket,globals.MessageInPort);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not open messaging receive socket.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not open messaging receive socket.");
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Opened messaging receive socket.");

	// open messaging send socket
	printf("BOOT: Opening messaging send socket.\n");
	sc = Socket_OpenSend(&txMsgSocket,globals.MessageOutURL,globals.MessageOutPort);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not open messaging send socket.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not open messaging send socket.");
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Opened messaging send socket.");

	// create messaging receive queue
	printf("BOOT: Creating messaging receive queue.\n");
	sc = MessageQueue_Create(&messageQueue,"/message");
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not create messaging receive queue.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not create messaging receive queue.");
		Socket_Close(&txMsgSocket);
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Created messaging receive queue.");

	// create messaging send queue
	printf("BOOT: Creating messaging send queue.\n");
	sc = MessageQueue_Create(&responseQueue,"/response");
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not create messaging send queue.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not create messaging send queue.");
		MessageQueue_Destroy(&messageQueue);
		Socket_Close(&txMsgSocket);
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Created messaging send queue.");


	// create data receive socket
	printf("BOOT: Creating data receive socket.\n");
	sc = Socket_Create(&rxSocket);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not create data receive socket.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not create data receive socket.");
		MessageQueue_Destroy(&responseQueue);
		MessageQueue_Destroy(&messageQueue);
		Socket_Close(&txMsgSocket);
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Created data receive socket.");

	// create data receive queue
	printf("BOOT: Creating data receive queue.\n");
	sc = RingQueue_Create(&rxQueue,16384);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Could not create data receive queue.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Could not create data receive queue.");
		Socket_Destroy(&rxSocket);
		MessageQueue_Destroy(&responseQueue);
		MessageQueue_Destroy(&messageQueue);
		Socket_Close(&txMsgSocket);
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("BOOT: Created data receive queue.");



	// open schedule
	printf("BOOT: Reading system schedule.\n");
	sc = Schedule_Open(BootOption_DeleteSchedule);
	if (sc!=SUCCESS){
		printf("BOOT: Fatal Error: Read system schedule.\nExiting...\n");
		Log_Add("BOOT: Fatal Error: Read system schedule.");
		RingQueue_Destroy(&rxQueue);
		Socket_Destroy(&rxSocket);
		MessageQueue_Destroy(&responseQueue);
		MessageQueue_Destroy(&messageQueue);
		Socket_Close(&txMsgSocket);
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}

	Log_Add("BOOT: Finished reading system schedule.");
	printf("BOOT: Booting Complete.\n");
	Log_Add("BOOT: Booting Complete.");

	//////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////
	//
	//        @@@@  @@@@   @@@@@   @@@@@@  @@   @@      @@     @@@@   @@@@  @@@@
	//        @@ @@@@ @@  @@   @@    @@    @@@  @@      @@    @@  @@ @@  @@ @@ @@
	//        @@  @@  @@  @@@@@@@    @@    @@ @ @@      @@    @@  @@ @@  @@ @@@@
	//        @@      @@  @@   @@    @@    @@  @@@      @@    @@  @@ @@  @@ @@
	//        @@      @@  @@   @@  @@@@@@  @@   @@      @@@@@  @@@@   @@@@  @@
	//
	//////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////
	/*printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	OperationParameters opp;

	ScheduleEntry temp1;
	ScheduleEntry temp2;
	ScheduleEntry conflict;
	TimeStamp now=getTimestamp();
	Schedule_ConstructEntry(&temp1, 123456, now.MJD+1, now.MPM,       now.MJD+1, now.MPM+1000, sizeof(OperationParameters), (char*)&opp);
	Schedule_ConstructEntry(&temp2, 123457, now.MJD+1, now.MPM+50000, now.MJD+1, now.MPM+100000, sizeof(OperationParameters), (char*)&opp);
	sc=Schedule_AddEntry(&temp1,&conflict);
	if (sc==SUCCESS){
		printf("\n\nSchedule SUCCESS, ref=%lu\n\n",temp1.reference);
	} else {
		printf("\n\nSchedule FAILED, ref=%lu\n\n",conflict.reference);
	}
	sc=Schedule_AddEntry(&temp2,&conflict);
	if (sc==SUCCESS){
		printf("\n\nSchedule SUCCESS, ref=%lu\n\n",temp2.reference);
	} else {
		printf("\n\nSchedule FAILED, ref=%lu\n\n",conflict.reference);
	}
	Schedule_ConstructEntry(&temp2, 123458, now.MJD+1, now.MPM,       now.MJD+1, now.MPM+10000, sizeof(OperationParameters), (char*)&opp);
	sc=Schedule_AddEntry(&temp2,&conflict);
	if (sc==SUCCESS){
		printf("\n\nSchedule SUCCESS, ref=%lu\n\n",temp2.reference);
	} else {
		printf("\n\nSchedule FAILED, ref=%lu\n\n",conflict.reference);
	}
	Schedule_ConstructEntry(&temp2, 123459, now.MJD+1, now.MPM+16000, now.MJD+1, now.MPM+30000, sizeof(OperationParameters), (char*)&opp);
	sc=Schedule_AddEntry(&temp2,&conflict);
	if (sc==SUCCESS){
		printf("\n\nSchedule SUCCESS, ref=%lu\n\n",temp2.reference);
	} else {
		printf("\n\nSchedule FAILED, ref=%lu\n\n",conflict.reference);
	}

	sc=Schedule_RemoveEntry(123456l);
	if (sc==SUCCESS){
		printf("\nREMOVE SUCCESS, ref=%lu\n\n",123456l);
	} else {
		printf("\nREMOVE FAILED, ref=%lu\n\n",123456l);
	}

	printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	printf("******************************************************************************\n");
	printf("******************************************************************************\n");

*/

	// Main control loop
	//globals.exitRequested=true;
	while(!globals.exitRequested){
		Process_Messaging();
		Process_Schedule();
		/*
			Process_Messaging();

			Process_Datapath();
			Process_Status();
		*/
	}

	//////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////
	//
	//      @@@@@@ @@   @@ @@   @@ @@@@@@      @@@@@   @@@@  @@   @@ @@   @@
	//      @@     @@   @@ @@   @@   @@        @@  @@ @@  @@ @@   @@ @@@  @@
	//      @@@@@@ @@@@@@@ @@   @@   @@        @@  @@ @@  @@ @@ @ @@ @@ @ @@
	//          @@ @@   @@ @@@ @@@   @@        @@  @@ @@  @@ @@@@@@@ @@  @@@
	//      @@@@@@ @@   @@  @@@@@    @@        @@@@@   @@@@   @@ @@  @@   @@
	//
	//////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////

	// close schedule
	printf("SHUTDOWN: Closing system schedule.\n");
	sc = Schedule_Close();
	if (sc!=SUCCESS){
		printf("SHUTDOWN: Fatal Error: close system schedule.\nExiting...\n");
		Log_Add("SHUTDOWN: Fatal Error: close system schedule.");
		RingQueue_Destroy(&rxQueue);
		Socket_Destroy(&rxSocket);
		MessageQueue_Destroy(&responseQueue);
		MessageQueue_Destroy(&messageQueue);
		Socket_Close(&txMsgSocket);
		Socket_Close(&rxMsgSocket);
		Socket_Destroy(&txMsgSocket);
		Socket_Destroy(&rxMsgSocket);
		DataFormats_Finalize();
		FileSystem_Close(&fileSystem);
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("SHUTDOWN: Closed system schedule.");

	if (!globals.scramRequested){

		// destroy data receive queue
		printf("SHUTDOWN: Destroying data receive queue.\n");
		sc = RingQueue_Destroy(&rxQueue);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not destroy data receive queue.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not destroy data receive queue.");
			Socket_Destroy(&rxSocket);
			MessageQueue_Destroy(&responseQueue);
			MessageQueue_Destroy(&messageQueue);
			Socket_Close(&txMsgSocket);
			Socket_Close(&rxMsgSocket);
			Socket_Destroy(&txMsgSocket);
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Destroyed data receive queue.");

		// destroy data receive socket
		printf("SHUTDOWN: Destroying data receive socket.\n");
		sc = Socket_Destroy(&rxSocket);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not destroy data receive socket.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not destroy data receive socket.");
			MessageQueue_Destroy(&responseQueue);
			MessageQueue_Destroy(&messageQueue);
			Socket_Close(&txMsgSocket);
			Socket_Close(&rxMsgSocket);
			Socket_Destroy(&txMsgSocket);
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Destroyed data receive socket.");

		// destroy messaging send queue
		printf("SHUTDOWN: Destroying messaging send queue.\n");
		sc = MessageQueue_Destroy(&responseQueue);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not destroy messaging send queue.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not destroy messaging send queue.");
			MessageQueue_Destroy(&messageQueue);
			Socket_Close(&txMsgSocket);
			Socket_Close(&rxMsgSocket);
			Socket_Destroy(&txMsgSocket);
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Destroyed messaging send queue.");

		// destroy messaging receive queue
		printf("SHUTDOWN: Destroying messaging receive queue.\n");
		sc = MessageQueue_Destroy(&messageQueue);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not destroy messaging receive queue.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not destroy messaging receive queue.");
			Socket_Close(&txMsgSocket);
			Socket_Close(&rxMsgSocket);
			Socket_Destroy(&txMsgSocket);
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Destroyed messaging receive queue.");

		// close messaging send socket
		printf("SHUTDOWN: Closing messaging send socket.\n");
		sc = Socket_Close(&txMsgSocket);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not close messaging send socket.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not close messaging send socket.");
			Socket_Close(&rxMsgSocket);
			Socket_Destroy(&txMsgSocket);
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Closed messaging send socket.");

		// close messaging receive socket
		printf("SHUTDOWN: Closing messaging receive socket.\n");
		sc = Socket_Close(&rxMsgSocket);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not close messaging receive socket.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not close messaging receive socket.");
			Socket_Destroy(&txMsgSocket);
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Closed messaging receive socket.");

		// destroy messaging send socket
		printf("SHUTDOWN: Destroying messaging send socket.\n");
		sc = Socket_Destroy(&txMsgSocket);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not destroy messaging send socket.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not destroy messaging send socket.");
			Socket_Destroy(&rxMsgSocket);
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Destroyed messaging send socket.");

		// destroy messaging send socket
		printf("SHUTDOWN: Destroying messaging receive socket.\n");
		sc = Socket_Destroy(&rxMsgSocket);
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not destroy messaging receive socket.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not destroy messaging receive socket.");
			DataFormats_Finalize();
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Destroyed messaging receive socket.");

		// close data formats database
		printf("SHUTDOWN: Closing data formats database.\n");
		sc = DataFormats_Finalize();
		if (sc!=SUCCESS){
			printf("SHUTDOWN: Fatal Error: Could not close data formats database.\nExiting...\n");
			Log_Add("SHUTDOWN: Fatal Error: Could not close data formats database.");
			FileSystem_Close(&fileSystem);
			Log_Close();
			Config_Finalize();
			return EXIT_CODE_FAIL;
		}
		Log_Add("SHUTDOWN: Closed messaging receive socket.");
	} // if "SCRAM"


	// close file system
	printf("SHUTDOWN: Closing internal storage file system.\n");
	sc = FileSystem_Close(&fileSystem);
	if (sc!=SUCCESS){
		printf("SHUTDOWN: Fatal Error: Could not close internal storage file system.\nExiting...\n");
		Log_Add("SHUTDOWN: Fatal Error: Could not close internal storage file system.");
		Log_Close();
		Config_Finalize();
		return EXIT_CODE_FAIL;
	}
	Log_Add("SHUTDOWN: Closed internal storage file system.");

	// close system log
	printf("SHUTDOWN: Closing system log.\n");
	Log_Close();


	// close config database
	printf("SHUTDOWN: Closing config database.\n");
	sc = Config_Finalize();
	if (sc!=SUCCESS){
		printf("SHUTDOWN: Fatal Error: Could not close config database.\nExiting...\n");
		return EXIT_CODE_FAIL;
	}
	int exitcode = 0;

	if (globals.flushConfigRequested)exitcode |= EXIT_CODE_FLUSH_CONFIG;
	if (globals.flushDataRequested) exitcode |= EXIT_CODE_FLUSH_DATA;
	if (globals.flushLogRequested) exitcode |= EXIT_CODE_FLUSH_LOG;
	if (globals.flushScheduleRequested) exitcode |= EXIT_CODE_FLUSH_SCHEDULE;
	if (globals.shutdownRequested) exitcode |= EXIT_CODE_SHUTDOWN;
	if (globals.rebootRequested) exitcode |= EXIT_CODE_REBOOT;
	return exitcode;
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//
//        @@@@@  @@@@@   @@@@   @@@@@  @@@@@@ @@@@@@ @@@@@@ @@@@@@ @@@@@@
//        @@  @@ @@  @@ @@  @@ @@@  @@ @@     @@     @@     @@     @@
//        @@@@@  @@@@@  @@  @@ @@      @@@@   @@@@@@ @@@@@@ @@@@   @@@@@@
//        @@     @@  @@ @@  @@ @@@  @@ @@         @@     @@ @@         @@
//        @@     @@  @@  @@@@   @@@@@  @@@@@@ @@@@@@ @@@@@@ @@@@@@ @@@@@@
//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
static BaseMessage messageJustIn;
static BaseMessage messageReadyToProcess;
static SafeMessage messageReadyToProcessConv;
static SafeMessage responseUnConv;
static BaseMessage response;
static BaseMessage responseReadyToSend;
static boolean processed = false;
static boolean busy_messageJustIn = false;
static boolean busy_messageReadyToProcess = false;
static boolean busy_responseReadyToSend = false;
static size_t bytesReceived;
static size_t bytesToSend;

void Process_Messaging(){
	StatusCode sc;

	if (!busy_messageJustIn){
		sc=Socket_Recieve(globals.rxMsgSocket,(char*)&messageJustIn, &bytesReceived);
		if (sc==SUCCESS){
			if ( (strncmp(messageJustIn.destination,globals.MyReferenceDesignator,MESSAGE_FIELDSIZE_DESTINATION)==0) ||
				 (strncmp(messageJustIn.destination,"ALL",MESSAGE_FIELDSIZE_DESTINATION)==0)){
				busy_messageJustIn=true;
			}
		}
	}
	if (busy_messageJustIn){
		sc=MessageQueue_Enqueue(globals.messageQueue,&messageJustIn);
		if (sc==SUCCESS){
			bzero((void*)&messageJustIn,sizeof(messageJustIn));
			busy_messageJustIn=false;
		} /*else {
			printf("sc= %s\n", ((sc==FAILURE)?"FAILURE":"NOT_READY"));
		}*/
	}
	if (!busy_messageReadyToProcess){
		sc=MessageQueue_Dequeue(globals.messageQueue,&messageReadyToProcess);
		if (sc==SUCCESS){
			//((char*)&messageReadyToProcess)[8191]='\0';
			//printf("%s\n",(char*)&messageReadyToProcess);
			busy_messageReadyToProcess=true;
		}
	}

	if (busy_messageReadyToProcess){
		if (!processed){
			MessageConvertBaseSafe(&messageReadyToProcess,&messageReadyToProcessConv);
			//printf("RefSafe %s  vs.   RefBase %s",messageReadyToProcessConv.reference,messageReadyToProcess.reference);
			//if (Message_Verify(&messageReadyToProcess)){
				sc = Command_Process(&messageReadyToProcessConv,&responseUnConv);
				//printf("Command_Process(&messageReadyToProcessConv,&responseUnConv) = %s\n",statusString(sc));fflush(stdout);
				if (sc!=SUCCESS){
					Log_Add("MESSAGING: Error: could not process message.");
					//TODO: when messaging fails
				}
				processed=true;
				printf("Processed\n");
			/*} else {
				sc = GenerateErrorResponse(&messageReadyToProcess,&response,ERROR_CODE_ILLEGAL_CHARACTERS,"");
				if (sc!=SUCCESS){
					Log_Add("MESSAGING: Error: could not process message.");
					//TODO: when messaging fails
				}
				processed=true;
			}*/
		}
		MessageConvertSafeBase(&responseUnConv,&response);
		sc=MessageQueue_Enqueue(globals.responseQueue,&response);
		if (sc==SUCCESS){
			bzero((void*)&messageReadyToProcess,sizeof(messageReadyToProcess));
			bzero((void*)&response,sizeof(response));
			busy_messageReadyToProcess=false;
			processed=false;
		}

	}
	if (!busy_responseReadyToSend){
		sc=MessageQueue_Dequeue(globals.responseQueue,&responseReadyToSend);
		if (sc==SUCCESS){
			busy_responseReadyToSend=true;
		}
	}
	if (busy_responseReadyToSend){
		bytesToSend = Message_TransmitSize(&responseReadyToSend);
		sc=Socket_Send(globals.txMsgSocket, (char *)&responseReadyToSend, bytesToSend);
		if (sc==SUCCESS){
			char buffer[256];
			snprintf(buffer,255,"%s",(char*)&responseReadyToSend);
			buffer[255]='\0';
			Log_Add("MESSAGING: Responded with: '%s'",buffer);
			busy_responseReadyToSend=false;
		}
	}
}
void Process_Operation(){
}

void Process_Status(){
}







