/*
 * Time.h
 *
 *  Created on: Oct 25, 2009
 *      Author: chwolfe2
 */

#ifndef TIME_H_
#define TIME_H_
#include <stdlib.h>
#include "Defines.h"
#define MILLISECONDS_PER_DAY (1000l*60l*60l*24l)
typedef struct __timestamp {
	size_t MPM;
	size_t MJD;
	size_t hour;
	size_t minute;
	size_t second;
	size_t millisecond;
	size_t year;
	size_t month;
	size_t day;
} TimeStamp;

TimeStamp getTimestamp();
size_t    getMPM();
size_t    getMJD();
size_t    getElapsedMilliseconds(TimeStamp start, TimeStamp stop);
boolean   before (size_t MJDa, size_t MPMa, size_t MJDb, size_t MPMb); // a is before b
boolean   after (size_t MJDa, size_t MPMa, size_t MJDb, size_t MPMb);  // a is after b
boolean   equal (size_t MJDa, size_t MPMa, size_t MJDb, size_t MPMb);  // a is equal to b
void      addTime(size_t MJD, size_t MPM, size_t milliseconds, size_t* resultMJD, size_t* resultMPM);
void      subTime(size_t MJD, size_t MPM, size_t milliseconds, size_t* resultMJD, size_t* resultMPM);
#endif /* TIME_H_ */
